program graf3d;   
 (* Peerenboom 5401 Spay Tel 02628/2619 *)
 {$r-} 

(* 14. April 1990 *)

 const
   Cmax=20; Rmax=20; len=80; maxlen=41;

 type kette=array[1..40] of char;
 var
    C1max,R1max, r,c,i,j,inlength,errcode : integer;
    Cang, Rang, Clen, Rlen,
    Angle, Elev, Cwide: real;
    Info: array [1..Rmax,1..Cmax] of real;
    Rnote: array [1..Rmax,1..40] of char;
    Cnote: array [1..Cmax,1..40] of char;
    Title: kette;
    fname: kette;
    Shade, color: colour;
    datei: file of char; 
    Smax : real;
    zeichen: char;
    f: text;

procedure pause;
 begin
  zeichen:=inkey(f,-1);
 end;
 
(* ------------ import 29.5.88 - in Zahlen umsetzen ----------- *)

function hoch(bas,hochz:real):real;
   begin
   hoch:=exp(ln(bas)*hochz);
   end;

function numwert (zahl: kette): real;
   var dez, neg : boolean;
       stelle: integer;
       wert: real;
       
function numeric (c: char): boolean;
   begin
      numeric :=( c>='0') and (c <= '9') or (c='-') or (c='.');
   end;

  begin
   wert:=0;
   i:=1; dez:=false; stelle:=0; neg:=false;
   while ((zahl[i] <> chr(10)) and (numeric(zahl[i])=true)) do      
   begin
   if zahl[i]='.' then dez:=true;
   if zahl[i]='-' then neg:=true;
   if (dez=false) and (zahl[i]<>'-') then 
      wert:=wert*10+(ord(zahl[i])-48);   
   if (dez=true) and (zahl[i]<> '.') and (zahl[i]<>'-') then
      begin
       stelle:=stelle+1;
       wert:=wert+((ord(zahl[i])-48)/hoch(10,stelle));
      end;
   i:=i+1;
   end;
   if neg=true then wert:= wert*(-1);
   numwert:=wert;
  end;

{-------------------------- Datei einlesen -------------------------}

procedure Wahl(var key: char);
var zchn , j :integer;
    aStr: array [1..40] of char;
    leer: array [1..40] of char;
begin
zchn:=ord(key);
for j:= 1 to 40 do leer[j]:=' '; 
if i=1 then  aStr:=leer;
if zchn = 10 then
 begin
      IF R1max > 1 then
         Info[R1max-1,c-1]:=numwert(aStr)
      ELSE 
       begin
       Cnote[c-1]:=aStr;
       c:=c+1; C1max:= c -1 ;  
      END;
      c:=1;
      if R1max <= Rmax then R1max:=R1max+1;
      aStr:=leer; i:=1;
     end;
if zchn= 44 then
  begin
      if (R1max=1) and (c=1) then Title:=aStr;
      IF (R1max=1) AND (c<>1) then Cnote[c-1]:=aStr;
      IF (R1max<>1) AND (c=1) then Rnote[R1max-1]:=aStr;
      IF (R1max<>1) AND (c<>1) then 
      begin
         i:=i+1;
         Info[R1max-1,c-1]:=numwert(aStr);
      end;
      if c<20 then c:=c+1;
      aStr:=leer; i:=1;
     end;
 if ((zchn>47)and(zchn<191)) or (zchn=ord('.')) or (zchn=ord('-'))
  then begin
      aStr[i]:= chr(zchn); i:=i+1
      end
    end; 

procedure GetFileName;
var inlength : integer;
    TitStr: kette;
begin
   writeln(f,' ganzen Dateinamen eingeben :');
   inlength:=getline(f,20,loc(TitStr));
    if TitStr[1] <> chr(10) then fname:=TitStr;
   attach(datei,fname);reset(datei);
end;

procedure filelesen;
begin i:=1; R1max:=1; C1max:=1;c:=1;
repeat
  GetFileName;
  if ioresult <> 0 then
  begin
    errcode:=ioresult;
    writeln(f,' Datei kann nicht geffnet werden ');
    writeln;
  end
  else begin errcode:= 0;
  writeln(f,' Importieren ... ');
  end
until errcode=0;
while (not eof(datei)) do
begin
     read (datei,zeichen);
           wahl (zeichen);   (* Einlesen in Stringfelder *)
end (* while *); close(datei);
R1max:=R1max-1;C1max:=C1max-1;
end;

{------------------- Ende Zahlen Umsetzen / Import ----------------}
 PROCedure Init;
 begin
  attach(f,'con'); rewrite (f);
  WINDOW(f,512,256,0,0);
  PAPER (f,black,black,0); INK(f,white,white,0); cls(f,0);
  POKEW (163980,10); POKEW (163982,1);
 END;
    
 PROCedure Scalex; 
 label 99;
 var xx,c,n,r: integer;
     x,y,eex,sx,Sstep: real;
     
 begin
 WINDOW(f,450,240,32,10); BORDER(f,1,white,white,0); CLS(f,0);
 SCALE(f,155,-35-Angle/3,-40-Elev/2);
 Cang:=RAD(30-Angle);
 Rang:=RAD(10+Angle+Elev);
 Clen:=72+Angle*2; Rlen:=90-Angle*2;
                  { find highest Data Value }
 Smax:=0.001;
 FOR c:=1 TO C1max do
  begin
   FOR r:=1 TO R1max do
   begin
      if Info [r,c] >Smax then Smax:= round(Info[r,c]);
   end
  end;
   if Smax=0 then Smax:=0.001;  
                  { calculate Scale Maximum}   
 eex:=round(ln(Smax)/ln(10)-0.5);
 FOR n:= 1 to 10 do
  begin
   if n in [2,4,5,8,10] then
   begin
    IF(n*hoch(10,eex)) >=Smax then
        begin
        Smax:=n*trunc(hoch(10,eex));
        goto 99
        end
    end;
   end;
99: ;
    Sstep:=4; if (n=5) or (n=10) then Sstep:=4+1;
      { Draw Scale } 
  ink(f,green,green,0);    
 FOR xx:=0 TO round(Smax) do
 begin
  gCURSOR(f,-34,xx*70/Smax+4,0,0); write(f,xx);
  LINE (f,0,xx*70/Smax,Clen*COS(Cang),xx*70/Smax+Clen*SIN(Cang));
  sx:=Smax/Sstep; if sx>1 then sx:=round(smax/Sstep-0.5);
  xx:=xx+round(sx);if xx >1 then xx:=xx-1;
 END;
  ink(f,white,white,0);
 END; (* Scalex *)

 PROCedure Box; 
 var r,c, Kante: integer;
     Cx,Cy,Rx,Ry,
     startX,startY,edgeX,endeX,edgeY,endeY,BoxTop: real;

 PROCedure Side(var face: integer);
 begin
 LINE(f,edgeX,edgeY,edgeX,edgeY+BoxTop);
   IF face=1 then
   begin      
      endeX:= edgeX+Cx; endeY:= edgeY+BoxTop+Cy;
      LINE(f,edgeX,edgeY+Boxtop,endeX,endeY) end
   ELSE begin
      endeX:= edgeX-Rx; endeY:=edgeY+BoxTop+Ry;
      LINE(f,edgeX,edgeY+Boxtop,endeX, endeY)
   END;
 LINE(f,endeX,endeY,endeX,endeY-BoxTop);
 LINE(f,endeX,endeY-Boxtop,edgeX,edgeY);
 END;
 
 PROCedure Top;
 begin
  line(f,edgeX,edgeY+BoxTop,edgeX-Rx,edgeY+Boxtop+Ry);
  line(f,edgeX-Rx,edgeY+Boxtop+Ry,edgeX-Rx+Cx,edgeY+Boxtop+Ry+Cy);
  line(f,edgeX-Rx+Cx,edgeY+Boxtop+Ry+Cy,
  edgeX-Rx+Cx+Rx,edgeY+Boxtop+Cy);
  line(f,edgeX-Rx+Cx+Rx,edgeY+Boxtop+Cy,edgeX,edgeY+BoxTop);
 END;

(* Box Hauptprozedur *)

 begin
 Cx:=1/C1max*Clen*COS(Cang)*Cwide;
 Cy:=1/C1max*Clen*SIN(Cang)*Cwide;
 Rx:=1/R1max*Rlen*COS(rang);
 Ry:=1/R1max*Rlen*SIN(rang);
 at(f,0,1); csize(f,2,0);write(f,Title);csize(f,0,0);
 FOR r:=1 TO R1max-1 do
 begin
   startX:=r*Rx; startY:=(-r*Ry);
   c:=C1max; while c > 0 do 
   begin   
   if (c mod 2)< 1 then
     begin color:= red; {+(c MOD 2);} shade:= white end
     else
     begin color:=green; shade:= black end;
     edgeX:=startX+(c-1)*Cx/Cwide;
     edgeY:=startY+(c-1)*Cy/Cwide;
     BoxTop:=Info[r,c]*70/Smax;
   if Boxtop>0 then
   begin
       grafill(f,true); INK(f,color,Shade,2); kante:=1;Side(Kante);
       grafill(f,true); INK(f,color, black,3); {7*(Shade=0):} Top;
       grafill(f,true); INK(f,color,color,0); Kante:=2; Side(Kante);
       grafill(f,false);
       INK(f,white,white,0); Top;Kante:=2;Side(Kante);
   end;     
     IF r=R1max-1 then
     begin
       gCURSOR(f,edgeX,edgeY+2,10,0);
       OVER(f,1); write(f,Cnote[c]); OVER(f,0);
       END; 
   c:=c-1;
    END;(*  While / FOR c *)
   gCURSOR(f,startX-3,startY+Elev/10,-8*10,0); {LEN(Rnote$(r)),0);}
 OVER(f,1); write(f,Rnote[r]); OVER(f,0);
 END; (* FOR r  pause; *)
 END;

procedure werte;
var i, inlength: integer;
    anStr, elStr,CwStr,TitStr: kette;
begin
   for i:=1 to 40 do TitStr[i]:=' ';
   cls(f,0);csize(f,2,0); writeln(f,' Grafikparameter');csize(f,0,0);
   writeln(f,chr(10),' ENTER behlt bisherige Werte bei! ');
   write(f,chr(10),'Winkel horizontal (',angle:3:0,') ? ');
    inlength:=getline(f,20,loc(anStr));
    if anStr[1] <> chr(10) then Angle:=numwert(anStr);
   write(f,'Winkel hoch (',elev:3:0,') ? ');
    inlength:=getline(f,20,loc(elStr));
    if elStr[1] <> chr(10) then Elev:=numwert(elStr);
   write(f,'Balkenbreite (',Cwide:5:2,') ? ');
    inlength:=getline(f,20,loc(CwStr));
    if CwStr[1] <> chr(10) then Cwide:=numwert(CwStr);
   writeln(f,'Titel ( "',Title,'" ) ? ');
    write(f,'  '); inlength:=getline(f,33,loc(TitStr));
    if TitStr[1] <> chr(10) then Title:=TitStr;
   end;

 procedure grafik;
  begin
   init; scalex; box; pause; end;

{-------------- Menue -------------------}

procedure menu;
var richtig: set of'0'..'9';
    antwort: char;
begin
   window(f,232,100,240,140);
   richtig:=['1','2','3','9'];
   paper(f,red,red,0); ink(f,white,white,0);
   BORDER(f,1,white,white,0); CLS(f,0);
   csize(f,2,0); writeln(f,' 3D - Grafik',chr(10));csize(f,0,0);
   writeln(f,'1 Parameter',chr(10),'2 Grafik');
   writeln(f,'3 Datei einlesen');
   writeln(f,chr(10),'9 verlassen');
   repeat
   antwort:=inkey(f,-1);
   if not (antwort in richtig) then menu;
   case antwort of
   '1': begin werte; grafik; menu end;
   '2': begin 
         grafik; menu
        end;  
   '3': begin
         cls(f,0); filelesen; grafik; menu
        end;
   '9': halt;
   end
   until antwort='9';
end;
  
 begin (* Hauptprogramm *)
 init;
 C1max:=5; R1max :=6; Angle:=15; Elev:=15; Cwide:=0.07; Shade:= black;
 Title :='keine Datei gelesen                     ';
 for i:=1 to R1max do begin
   Rnote[i]:=  'leer                                    ';
   for j:=1 to C1max do begin
     Cnote[j]:=Rnote[1];
     Info[i,j]:=0;
     end;
 end; 
 init; scalex; box; menu;
 end.
